 package Controllers.Client;

import Controllers.Traitement.MyWindow;
import Models.Client.ClientEntrepriseDB;
import javafx.scene.control.ProgressBar;
import java.io.IOException;
import java.net.URL;
import java.util.ResourceBundle;
import org.apache.log4j.Logger;
import javafx.beans.value.ChangeListener;
import javafx.beans.value.ObservableValue;
import javafx.collections.FXCollections;
import javafx.collections.ObservableList;
import javafx.concurrent.Service;
import javafx.concurrent.Task;
import javafx.concurrent.WorkerStateEvent;
import javafx.event.ActionEvent;
import javafx.event.EventHandler;
import javafx.fxml.FXML;
import javafx.fxml.FXMLLoader;
import javafx.fxml.Initializable;
import javafx.scene.Group;
import javafx.scene.Node;
import javafx.scene.Scene;
import javafx.scene.control.Button;
import javafx.scene.control.ChoiceBox;
import javafx.scene.control.Label;
import javafx.scene.control.RadioButton;
import javafx.scene.control.TableColumn;
import javafx.scene.control.TableView;
import javafx.scene.control.TextField;
import javafx.scene.control.cell.PropertyValueFactory;
import javafx.scene.input.KeyCode;
import javafx.scene.input.KeyEvent;
import javafx.scene.input.MouseEvent;
import javafx.scene.layout.AnchorPane;
import javafx.scene.layout.StackPane;
import javafx.scene.text.Text;
import javafx.stage.Stage;

/**
 * FXML Controller class
 * @author Maher Ben Tili
 */
public class RechercherClientEntrepriseController implements Initializable {

    Logger logger = Logger.getLogger(RechercherClientEntrepriseController.class.getName());
    
    @FXML public AnchorPane AnchoreClientEntre ;
    
    public Node nodeFxmlEtr ;
    
    @FXML private ProgressBar ProgressBarClientEntreprise;
    
    @FXML public RadioButton cltPer ;
    @FXML public RadioButton cltEtr ;
    
    @FXML private Text ActuellePage ;
    @FXML private Text NbrPage ;
    @FXML private Group nextgroupe ;
    @FXML private Group avancergroupe ;
    @FXML private Group lastgroupe ;        
    @FXML private Group retourgroupe ;
    @FXML private Label LabelCount ;
    @FXML private ChoiceBox NbrLigne ;
    
    @FXML private Button ButtonSearchClientEntreprise;
    
    @FXML private TextField RerchercheCodeEtr;
    @FXML private TextField RerchercheNomEtr;       
    @FXML private TextField RerchercheGerantEtr;
    @FXML private TextField RerchercheMatriculeEtr;
    @FXML private TextField RerchercheAdresseEtr;       
    @FXML private TextField RerchercheTelephoneEtr;
    
    @FXML private TableView<ListeClientEntreprise> TableViewListeClientEntreprise ;
    
    @FXML private TableColumn<ListeClientEntreprise ,String> TableColumnCodeClientEtr;
    @FXML private TableColumn<ListeClientEntreprise ,String> TableColumnNomEntreprise;
    @FXML private TableColumn<ListeClientEntreprise ,String> TableColumnGerant ;
    @FXML private TableColumn<ListeClientEntreprise ,String> TableColumnMatricule;
    @FXML private TableColumn<ListeClientEntreprise ,String> TableColumnAdresse;
    @FXML private TableColumn<ListeClientEntreprise ,Integer> TableColumnTelephone;
    @FXML public TableColumn<ListeClientEntreprise, String> TableColumnActionEtre ;
    
    ObservableList cursors = FXCollections.observableArrayList("10","15","20");
    private Integer nbrligne = 10 ;
    private Integer totalcount = 0;
    private Integer nbrpage = 0;
    private Integer actuellepage = 1;
    Integer position = 0;
    
    private Service<Void> ThreadSearchRechercheClientEntreprise;
    
    public RechercherClientEntrepriseController(){
        try {
            FXMLLoader fxmlLoader = new FXMLLoader(getClass().getResource("/Views/Client/RechercherClientEntreprise.fxml"));
            fxmlLoader.setController(this);
            nodeFxmlEtr = (Node) fxmlLoader.load();
        } catch (IOException ex) {
            logger.error("RechercherClientEntrepriseController  : RechercherClientEntreprise.fxml :" + ex.getMessage());
        }
    }
    
    @Override
    public void initialize(URL url, ResourceBundle rb) {
        
        TableColumnCodeClientEtr.setCellValueFactory(new PropertyValueFactory<ListeClientEntreprise, String>("code"));
        TableColumnNomEntreprise.setCellValueFactory(new PropertyValueFactory<ListeClientEntreprise, String>("NomEntreprise"));
        TableColumnGerant.setCellValueFactory(new PropertyValueFactory<ListeClientEntreprise, String>("Gerant"));
        TableColumnMatricule.setCellValueFactory(new PropertyValueFactory<ListeClientEntreprise, String>("matricule"));
        TableColumnAdresse.setCellValueFactory(new PropertyValueFactory<ListeClientEntreprise, String>("Adresse"));
        TableColumnTelephone.setCellValueFactory(new PropertyValueFactory<ListeClientEntreprise, Integer>("Telephone"));
        
        TableColumnActionEtre.setStyle( "-fx-alignment: CENTER;");
        TableColumnActionEtre.getStyleClass().add("Center");
        
        //comboboxnombre des lignes tableview
        NbrLigne.setItems(cursors);
        NbrLigne.getSelectionModel().selectFirst();
        
        ButtonSearchClientEntreprise.setOnMouseClicked(new EventHandler<MouseEvent>() {
            public void handle(MouseEvent me) {
                SearchClientEntreprise();
            }
        });
        
        AnchoreClientEntre.setOnKeyPressed(new EventHandler<KeyEvent>() {
            @Override
            public void handle(KeyEvent ke) {
                if (ke.getCode().equals(KeyCode.ENTER)) {
                    SearchClientEntreprise();
                }
            }
        });
        
        GestionSearchClientEntreprise();
        
    }    
    
    
    
    
    @FXML
    private void QuiterButtonAction(ActionEvent event) throws IOException {
        AnchoreClientEntre.setVisible(false);
    }
    
    public void Show()
    {
        StackPane Sp = new StackPane();
            
        Scene scene = new Scene(Sp);
        
        Sp.setPrefSize((double)MyWindow.PrincipalContentWidth, (double)MyWindow.PrincipalContentHeight);
        
        Stage stage = MyWindow.myStage;
        
        
        Sp.getChildren().add(MyWindow.myParent);
        Sp.getChildren().add(nodeFxmlEtr);
            
        stage.setScene(scene);
        stage.show();
        
        cltEtr.setSelected(true);
    }
    
    
    
      
/******************************************************************************                                                                             *
 *                                                                              *
 *                       Methode last Next TableView                            *
 * *                                                                            *
 ******************************************************************************/  
 
    private void SearchClientEntreprise()
    {
        ProgressBarClientEntreprise.setVisible(true);
        
        ButtonSearchClientEntreprise.setDisable(true);
        
        ThreadSearchRechercheClientEntreprise = new Service<Void>(){
            @Override
            protected Task<Void> createTask(){
                return new Task<Void>(){
                    @Override
                    protected Void call() throws Exception{
                        
                        position = 0;
                        
                        actuellepage = 1;
                        
                        ObservableList<ListeClientEntreprise> ListeCltEntreprise = new ClientEntrepriseDB().SearchCltEntrepriseGestion(
                                                                                        position, 
                                                                                        nbrligne, 
                                                                                        RerchercheCodeEtr.getText(), 
                                                                                        RerchercheNomEtr.getText(),  
                                                                                        RerchercheGerantEtr.getText(), 
                                                                                        RerchercheMatriculeEtr.getText(),
                                                                                        RerchercheAdresseEtr.getText(),
                                                                                        RerchercheTelephoneEtr.getText());
                            
                        TableViewListeClientEntreprise.setItems(ListeCltEntreprise);
                        
                        totalcount = new ClientEntrepriseDB().nbrCltEntrepriseGestion(RerchercheCodeEtr.getText(), RerchercheNomEtr.getText(), RerchercheGerantEtr.getText(), RerchercheMatriculeEtr.getText(), RerchercheAdresseEtr.getText(), RerchercheTelephoneEtr.getText());
                        
                        if(totalcount > 0){
                            ActuellePage.setText("1");
                        }else{
                            ActuellePage.setText("0");
                        }
                        
                        if(totalcount % nbrligne==0){ 
                            nbrpage = totalcount / nbrligne ;
                        }
                        else{ 
                            nbrpage = (totalcount / nbrligne) + 1 ; 
                        }
                        NbrPage.setText(Integer.toString(nbrpage));
                        
                        return null;
                    }
                };
            }
	};
        
        ThreadSearchRechercheClientEntreprise.setOnSucceeded(new EventHandler<WorkerStateEvent>(){
            @Override
            public void handle(WorkerStateEvent event){
                ProgressBarClientEntreprise.setVisible(false);
                ButtonSearchClientEntreprise.setDisable(false);
                LabelCount.setText(totalcount.toString());
                
            }
        });
        ThreadSearchRechercheClientEntreprise.start();
    }
    
    
    
    private void NextLastSearchClientEntreprise(Integer ParmPosition, Integer ParamNbrligne)
    {
        ProgressBarClientEntreprise.setVisible(true);
        
        ButtonSearchClientEntreprise.setDisable(true);
        
        ThreadSearchRechercheClientEntreprise = new Service<Void>(){
            @Override
            protected Task<Void> createTask(){
                return new Task<Void>(){
                    @Override
                    protected Void call() throws Exception{
                        
                        ObservableList<ListeClientEntreprise> ListeCltEntreprise = new ClientEntrepriseDB().SearchCltEntrepriseGestion(
                                                                                        ParmPosition, 
                                                                                        ParamNbrligne, 
                                                                                        RerchercheCodeEtr.getText(), 
                                                                                        RerchercheNomEtr.getText(),  
                                                                                        RerchercheGerantEtr.getText(), 
                                                                                        RerchercheMatriculeEtr.getText(),
                                                                                        RerchercheAdresseEtr.getText(),
                                                                                        RerchercheTelephoneEtr.getText());
                            
                        TableViewListeClientEntreprise.setItems(ListeCltEntreprise);
                        
                        
                        return null;
                    }
                };
            }
	};
        
        ThreadSearchRechercheClientEntreprise.setOnSucceeded(new EventHandler<WorkerStateEvent>(){
            @Override
            public void handle(WorkerStateEvent event){
                ProgressBarClientEntreprise.setVisible(false);
                ButtonSearchClientEntreprise.setDisable(false);
            }
        });
        ThreadSearchRechercheClientEntreprise.start();
    }
  
    private void GestionSearchClientEntreprise()
    {
        NbrLigne.getSelectionModel().selectedIndexProperty().addListener(new ChangeListener<Number>() {

            public void changed(ObservableValue ov,  Number value, Number new_value) {
                nbrligne= Integer.parseInt((String) cursors.get(new_value.intValue()));
                if(totalcount % nbrligne==0){ nbrpage = totalcount / nbrligne ;}
                else{ nbrpage = (totalcount / nbrligne) + 1 ; }
                NbrPage.setText(Integer.toString(nbrpage));
                position=0;
                ActuellePage.setText("1");
                actuellepage=1;
                NextLastSearchClientEntreprise(position, nbrligne);
            }
        });

        if(totalcount % nbrligne==0){ nbrpage = totalcount / nbrligne ;}
        else{ nbrpage = (totalcount / nbrligne) + 1 ; }
        NbrPage.setText(Integer.toString(nbrpage));


        //next page
        nextgroupe.setOnMousePressed(new EventHandler<MouseEvent>(){
            @Override
            public void handle(MouseEvent event) {
                if(actuellepage<nbrpage)
                {
                    position=position+nbrligne;
                    NextLastSearchClientEntreprise(position, nbrligne);
                    actuellepage=actuellepage+1 ;
                    ActuellePage.setText(Integer.toString(actuellepage));

                }
            }
        }); 

        //last page
        lastgroupe.setOnMousePressed(new EventHandler<MouseEvent>(){
            @Override
            public void handle(MouseEvent event) {
                if(actuellepage>1)
                {
                    position=position-nbrligne;
                    NextLastSearchClientEntreprise(position, nbrligne);
                    actuellepage=actuellepage-1 ;
                    ActuellePage.setText(Integer.toString(actuellepage));
                }
            }
        }); 

        //next page avec pas de 5
        avancergroupe.setOnMousePressed(new EventHandler<MouseEvent>(){
            @Override
            public void handle(MouseEvent event) {
                if(actuellepage+3<nbrpage)
                {
                    position=(position+4)+nbrligne;
                    NextLastSearchClientEntreprise(position, nbrligne);
                    actuellepage=actuellepage+3 ;
                    ActuellePage.setText(Integer.toString(actuellepage));

                }
            }
        });

        //last page avec un pas de -5
        retourgroupe.setOnMousePressed(new EventHandler<MouseEvent>(){
            @Override
            public void handle(MouseEvent event) {
                if(actuellepage-3>1){
                    position=(position-4)-nbrligne;
                    NextLastSearchClientEntreprise(position, nbrligne);
                    actuellepage=actuellepage-3 ;
                    ActuellePage.setText(Integer.toString(actuellepage));
                }
            }
        });

    }
    
}
